import { coerceBooleanProperty } from '@angular/cdk/coercion';
import * as i0 from '@angular/core';
import { InjectionToken, Directive, Inject, HostListener, Input, Component, ChangeDetectionStrategy, forwardRef, SkipSelf, ContentChildren, ViewContainerRef, ContentChild, ViewChild, HostBinding, EventEmitter, Attribute, Output, NgModule } from '@angular/core';
import { Subject, takeUntil, startWith, map, isObservable, BehaviorSubject, tap, switchMap, first, ReplaySubject } from 'rxjs';
import * as i1$1 from '@angular/cdk/overlay';
import { CdkOverlayOrigin, OverlayModule } from '@angular/cdk/overlay';
import { MapEmit } from '@k5cjs/selection-model';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { TemplatePortal } from '@angular/cdk/portal';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { KcControl, kcControlProviders } from '@k5cjs/control';
import * as i2 from '@angular/cdk/a11y';

const KC_SELECT = new InjectionToken('KC_SELECT');

const KC_SELECTION = new InjectionToken('KC_SELECTION');

// eslint-disable-next-line @typescript-eslint/no-redundant-type-constituents
const KC_VALUE = new InjectionToken('KC_VALUE');

class KcClearDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
    }
    onClick() {
        this._kcSelect.clear();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcClearDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcClearDirective, selector: "[kcClear]", host: { listeners: { "click": "onClick()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcClearDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcClear]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class KcCloseDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
        this.kcClose = true;
    }
    onClick(event) {
        if (this.kcClose)
            this._kcSelect.close(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcCloseDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "16.1.0", version: "18.0.6", type: KcCloseDirective, selector: "[kcClose]", inputs: { kcClose: ["kcClose", "kcClose", coerceBooleanProperty] }, host: { listeners: { "click": "onClick($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcCloseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcClose]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { kcClose: [{
                type: Input,
                args: [{ transform: coerceBooleanProperty }]
            }], onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class KcDeselectAllDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
    }
    click() {
        this._kcSelect.deselectAll();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcDeselectAllDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcDeselectAllDirective, selector: "[kcDeselectAll]", host: { listeners: { "click": "click()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcDeselectAllDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcDeselectAll]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { click: [{
                type: HostListener,
                args: ['click']
            }] } });

class KcGroupDirective {
    constructor(_template, _viewContainer, _cdr) {
        this._template = _template;
        this._viewContainer = _viewContainer;
        this._cdr = _cdr;
    }
    static ngTemplateContextGuard(_dir, _ctx) {
        return true;
    }
    render(options) {
        if (this._embeddedViewRef)
            this._embeddedViewRef.context.$implicit = options;
        else
            this._embeddedViewRef = this._viewContainer.createEmbeddedView(this._template, { $implicit: options });
        this._cdr.detectChanges();
    }
    clear() {
        this._embeddedViewRef = undefined;
        this._viewContainer.clear();
        this._cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcGroupDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcGroupDirective, selector: "[kcGroup]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcGroupDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcGroup]',
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }, { type: i0.ChangeDetectorRef }] });

class KcOptionDirective {
    constructor(template) {
        this.template = template;
    }
    static ngTemplateContextGuard(_dir, _ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcOptionDirective, selector: "[kcOption]", inputs: { type: ["kcOptionType", "type"] }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[kcOption]' }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }], propDecorators: { type: [{
                type: Input,
                args: ['kcOptionType']
            }] } });

class KcOptionsDirective {
    constructor(_template, _viewContainer, _cdr) {
        this._template = _template;
        this._viewContainer = _viewContainer;
        this._cdr = _cdr;
    }
    static ngTemplateContextGuard(_dir, _ctx) {
        return true;
    }
    render(options) {
        if (this._embeddedViewRef)
            this._embeddedViewRef.context.$implicit = options;
        else
            this._embeddedViewRef = this._viewContainer.createEmbeddedView(this._template, { $implicit: options });
        this._cdr.detectChanges();
    }
    clear() {
        this._embeddedViewRef = undefined;
        this._viewContainer.clear();
        this._cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionsDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcOptionsDirective, selector: "[kcOptions]", inputs: { type: ["kcOptionsType", "type"] }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionsDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[kcOptions]' }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }, { type: i0.ChangeDetectorRef }], propDecorators: { type: [{
                type: Input,
                args: ['kcOptionsType']
            }] } });

class KcOriginDirective extends CdkOverlayOrigin {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOriginDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcOriginDirective, selector: "[kcOrigin]", exportAs: ["kcOrigin"], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOriginDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcOrigin]',
                    exportAs: 'kcOrigin',
                }]
        }] });

class KcSelectAllDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
    }
    click() {
        this._kcSelect.selectAll();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectAllDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcSelectAllDirective, selector: "[kcSelectAll]", host: { listeners: { "click": "click()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectAllDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcSelectAll]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { click: [{
                type: HostListener,
                args: ['click']
            }] } });

class KcSubmitDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
    }
    click() {
        this._kcSelect.submit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSubmitDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcSubmitDirective, selector: "[kcSubmit]", host: { listeners: { "click": "click()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSubmitDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcSubmit]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { click: [{
                type: HostListener,
                args: ['click']
            }] } });

class KcToggleDirective {
    constructor(_kcSelect) {
        this._kcSelect = _kcSelect;
    }
    click() {
        this._kcSelect.toggle();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcToggleDirective, deps: [{ token: KC_SELECT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcToggleDirective, selector: "[kcToggle]", host: { listeners: { "click": "click()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[kcToggle]',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { click: [{
                type: HostListener,
                args: ['click']
            }] } });

class KcValueDirective {
    constructor(template, _cdr) {
        this.template = template;
        this._cdr = _cdr;
    }
    render(viewContainer) {
        viewContainer.createEmbeddedView(this.template);
        this._cdr.detectChanges();
    }
    clear(viewContainer) {
        viewContainer.clear();
        this._cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcValueDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "18.0.6", type: KcValueDirective, selector: "[kcValue]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcValueDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[kcValue]' }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }, { type: i0.ChangeDetectorRef }] });

const isOptionChunks = (option) => Array.isArray(option) && Array.isArray(option[0]);

const isOptionGroupValue = (option) => typeof option === 'object' && option !== null && !Array.isArray(option);

class MapEmitSelect extends MapEmit {
    constructor(multiple, initiallyValues) {
        super(multiple, initiallyValues);
    }
    get test() {
        const selected = super.selectedEntries;
        if (selected) {
            if (this._isUnion(selected))
                return selected.map(([, value]) => value);
            else {
                const [k, value] = selected;
                const key = k;
                if (this._isMapEmitSelect(value))
                    return { [key]: value.selected };
                return { [key]: value };
            }
        }
        return selected;
    }
    _isMapEmitSelect(value) {
        return value instanceof MapEmitSelect;
    }
    _isUnion(value) {
        return Array.isArray(value[0]);
    }
}

const compareOptions = (value, option) => {
    if (typeof value === 'undefined')
        return false;
    if (option.compareFn)
        return option.compareFn(value, option.value);
    if ('key' in option)
        return option.key === value;
    return option.value === value;
};
const simpleOptions = (options, value) => {
    if (isOptionChunks(options)) {
        return options.flat().filter((option) => {
            if (Array.isArray(value))
                return value.some((value) => compareOptions(value, option));
            return compareOptions(value, option);
        });
    }
    else {
        return options.filter((option) => {
            if (Array.isArray(value))
                return value.some((value) => compareOptions(value, option));
            return compareOptions(value, option);
        });
    }
};
const groupOptions = (options, values) => {
    return Object.entries(options)
        .filter(([key]) => values[key])
        .map(([key, { value }]) => {
        const allOptions = value;
        const selectedValues = values[key];
        // TODO: check if is nested group
        const selectedValue = selectedValues;
        const filter = allOptions.filter((option) => {
            if (Array.isArray(selectedValue))
                return selectedValue.some((value) => value === option.key || value === option.value);
            return selectedValue === option.key || selectedValue === option.value;
        });
        const selectedOptions = filter.map((option) => [option.key || option.value, option]);
        const group = Array.isArray(selectedValue)
            ? new MapEmitSelect(true, selectedOptions)
            : new MapEmitSelect(false, selectedOptions[0]);
        return {
            key,
            value: group,
        };
    }).map((option) => [option.key || option.value, option.value]);
};
const getSelectedOptions = (options, value) => {
    if (typeof value === 'undefined')
        return undefined;
    if (Array.isArray(options)) {
        return simpleOptions(options, value).map((option) => [option.key || option.value, option]);
    }
    else if (options) {
        if (isOptionGroupValue(value))
            return groupOptions(options, value);
        throw new Error('Value is not a group value');
    }
    return undefined;
};

function getValues(values) {
    /**
     * check if map is multiple
     * is is multiple we need to iterate over all values
     */
    if (values.isMultiple()) {
        return values.selectedEntries.reduce((acc, [key, item]) => {
            if (checkIsOption(item))
                return [...acc, item.value];
            /**
             * check if accumulator is an array that means is the first iteration
             * when we have a nested group we change the accumulator to an object
             */
            if (Array.isArray(acc))
                acc = {};
            /**
             * get value from nested group
             */
            const value = getValues(item);
            /**
             * when the group has no value we return the accumulator
             */
            if (checkIsEmpty(value))
                return acc;
            return {
                ...acc,
                [key]: value,
            };
        }, []);
    }
    if (!values.selectedEntries)
        return;
    const [key, item] = values.selectedEntries;
    if (checkIsOption(item))
        return item.value;
    const value = getValues(item);
    if (checkIsEmpty(value))
        return;
    return { [key]: value };
}
// eslint-disable-next-line @typescript-eslint/ban-types
function checkIsEmpty(item) {
    /**
     * check if items is undefined
     */
    if (item === undefined)
        return true;
    /**
     * check if object is empty
     */
    if (typeof item === 'object' && Object.keys(item || {}).length === 0)
        return true;
    /**
     * check if array and is empty
     */
    if (Array.isArray(item) && item.length === 0)
        return true;
    return false;
}
function checkIsOption(item) {
    return !(item instanceof MapEmitSelect);
}

class KcOptionComponent {
    constructor(_selection, _cdr) {
        this._selection = _selection;
        this._cdr = _cdr;
        this._destroy = new Subject();
        this._selection.changed.pipe(takeUntil(this._destroy)).subscribe(() => this._cdr.markForCheck());
    }
    ngOnDestroy() {
        this._destroy.next();
        this._destroy.complete();
    }
    get selected() {
        return this._selection.has(this.option.key || this.option.value);
    }
    click() {
        this.toggle();
    }
    toggle() {
        if (this.selected)
            this.deselect();
        else
            this.select();
    }
    select() {
        this._selection.set(this.option.key || this.option.value, this.option);
    }
    deselect() {
        this._selection.delete(this.option.key || this.option.value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionComponent, deps: [{ token: KC_SELECTION }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.6", type: KcOptionComponent, selector: "kc-option", inputs: { option: "option" }, host: { listeners: { "click": "click()" } }, ngImport: i0, template: "<span>{{ option.label }}</span>\n<span *ngIf=\"selected\">(selected)</span>\n", styles: [""], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kc-option', changeDetection: ChangeDetectionStrategy.OnPush, template: "<span>{{ option.label }}</span>\n<span *ngIf=\"selected\">(selected)</span>\n" }]
        }], ctorParameters: () => [{ type: MapEmitSelect, decorators: [{
                    type: Inject,
                    args: [KC_SELECTION]
                }] }, { type: i0.ChangeDetectorRef }], propDecorators: { option: [{
                type: Input
            }], click: [{
                type: HostListener,
                args: ['click']
            }] } });

function provideKcOption(type) {
    return {
        provide: KcOptionComponent,
        useExisting: forwardRef(() => type),
    };
}

const isOptionGroup = (option) => !!option.value;

function filterNestedOptions(options, search) {
    if (isOptionChunks(options))
        return options.map((option) => filterNestedOptions(option, search));
    else if (Array.isArray(options))
        return options.filter((option) => option.label?.toLowerCase().includes(search.toLowerCase()));
    else {
        return Object.entries(options).reduce((acc, [key, item]) => {
            if (isOptionGroup(item))
                acc[key] = {
                    ...item,
                    value: isOptionChunks(item.value)
                        ? filterNestedOptions(item.value, search)
                        : filterNestedOptions(item.value, search),
                };
            else
                acc[key] = filterNestedOptions(item, search);
            return acc;
        }, {});
    }
}

class KcGroupComponent {
    get options() {
        return this._options;
    }
    set options(options) {
        this._options = options;
        this._render();
    }
    get multiple() {
        return this._multiple;
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    constructor(_selection, _select) {
        this._selection = _selection;
        this._select = _select;
        this._multiple = false;
        this._destroy = new Subject();
    }
    get value() {
        const value = this._select.value;
        if (this._isOptionGroupValue(value))
            return value[this.key];
        return value;
    }
    ngAfterContentInit() {
        this._render();
    }
    ngOnInit() {
        this._initSelection();
    }
    ngOnDestroy() {
        this._destroy.next();
    }
    _initSelection() {
        this.selection = this._getSelection();
        /**
         * If the selection is empty, set the selection to the current option.
         * we need to check if the selection is empty because the selection can be set from previous render.
         */
        if (this._selection.isEmpty())
            this._selection.set(this.key, this.selection);
        this.selection.changed.pipe(takeUntil(this._destroy)).subscribe(() => {
            if (this._selection.has(this.key))
                this._selection.update(this.key, this.selection);
            else
                this._selection.set(this.key, this.selection);
        });
    }
    _render() {
        if (!this.groups)
            return;
        this.groups.forEach((group) => group.render(this._getGroup(this.options)));
        this.option.forEach((group, index) => group.render(this._getOptions(this.options)[index]));
    }
    _getSelection() {
        if (this._selection.has(this.key))
            return this._selection.get(this.key);
        const option = this._getOption();
        const options = option && (this.multiple ? option : option[0]);
        return new MapEmitSelect(this.multiple, options);
    }
    _getOption() {
        if (this._isOptionGroup(this.options[this.key]))
            return this._getOptions(this.options)
                .flat()
                .filter((option) => {
                if (Array.isArray(this.value))
                    return this.value.some((value) => value === option.value);
                return this.value === option.value;
            })
                .map((option) => [(option.key || option.value), option]);
        return undefined;
    }
    _getGroup(options) {
        return options[this.key];
    }
    _getOptionGroup(options) {
        return options[this.key];
    }
    _getOptions(options) {
        const value = this._getOptionGroup(options).value;
        if (this._isOptionChunks(value))
            return value;
        return [value];
    }
    _isOptionGroup(option) {
        return !!option.value;
    }
    _isOptionGroupValue(value) {
        return typeof value === 'object' && !Array.isArray(value);
    }
    _isOptionChunks(option) {
        return Array.isArray(option[0]);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcGroupComponent, deps: [{ token: KC_SELECTION, skipSelf: true }, { token: KC_SELECT, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.6", type: KcGroupComponent, selector: "kc-group", inputs: { options: "options", key: "key", multiple: "multiple" }, providers: [
            {
                provide: KC_SELECTION,
                useFactory: (autocomplete) => autocomplete.selection,
                deps: [forwardRef(() => KcGroupComponent)],
            },
            {
                provide: KC_VALUE,
                useFactory: (component) => component.value,
                deps: [forwardRef(() => KcGroupComponent)],
            },
        ], queries: [{ propertyName: "groups", predicate: KcGroupDirective }, { propertyName: "option", predicate: KcOptionsDirective }], ngImport: i0, template: "<!-- ng-content is for header elements and for options template -->\n<ng-content></ng-content>\n<!-- ng-content is for footer elements -->\n<ng-content select=\"[footer]\"></ng-content>\n", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kc-group', providers: [
                        {
                            provide: KC_SELECTION,
                            useFactory: (autocomplete) => autocomplete.selection,
                            deps: [forwardRef(() => KcGroupComponent)],
                        },
                        {
                            provide: KC_VALUE,
                            useFactory: (component) => component.value,
                            deps: [forwardRef(() => KcGroupComponent)],
                        },
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- ng-content is for header elements and for options template -->\n<ng-content></ng-content>\n<!-- ng-content is for footer elements -->\n<ng-content select=\"[footer]\"></ng-content>\n" }]
        }], ctorParameters: () => [{ type: MapEmitSelect, decorators: [{
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [KC_SELECTION]
                }] }, { type: undefined, decorators: [{
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [KC_SELECT]
                }] }], propDecorators: { options: [{
                type: Input
            }], key: [{
                type: Input
            }], multiple: [{
                type: Input
            }], groups: [{
                type: ContentChildren,
                args: [KcGroupDirective]
            }], option: [{
                type: ContentChildren,
                args: [KcOptionsDirective]
            }] } });

class KcOptionsComponent {
    get options() {
        return this._options;
    }
    set options(options) {
        this._options = options;
        this._render();
    }
    _render() {
        // TODO: implement trackBy
        this._outlet.clear();
        this.options.forEach((option) => {
            const dialog = this.optionTemplate.template.createEmbeddedView({ $implicit: option });
            this._outlet.insert(dialog);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.6", type: KcOptionsComponent, selector: "kc-options", inputs: { options: "options" }, queries: [{ propertyName: "optionTemplate", first: true, predicate: KcOptionDirective, descendants: true, static: true }], viewQueries: [{ propertyName: "_outlet", first: true, predicate: ["outlet"], descendants: true, read: ViewContainerRef, static: true }], ngImport: i0, template: "<!-- ng-content is for header elements and for option template -->\n<ng-content></ng-content>\n<!-- ng-template is to render all the options -->\n<ng-template #outlet></ng-template>\n<!-- ng-content is for footer elements -->\n<ng-content select=\"[footer]\"></ng-content>\n", styles: [":host{display:flex;flex-direction:column}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcOptionsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kc-options', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- ng-content is for header elements and for option template -->\n<ng-content></ng-content>\n<!-- ng-template is to render all the options -->\n<ng-template #outlet></ng-template>\n<!-- ng-content is for footer elements -->\n<ng-content select=\"[footer]\"></ng-content>\n", styles: [":host{display:flex;flex-direction:column}\n"] }]
        }], propDecorators: { options: [{
                type: Input
            }], optionTemplate: [{
                type: ContentChild,
                args: [KcOptionDirective, { static: true }]
            }], _outlet: [{
                type: ViewChild,
                args: ['outlet', { static: true, read: ViewContainerRef }]
            }] } });

class KcValueComponent {
    constructor(_selection) {
        this._selection = _selection;
        this.value = this._selection.changed.pipe(startWith({ source: { selected: this._selection.selected } }), map(({ source: { selected } }) => {
            if (Array.isArray(selected))
                return selected.map(({ label }) => label).join(', ');
            else if (selected && selected.label)
                return selected.label;
            else if (selected && typeof selected === 'object')
                return 'Object logic';
            return;
        }));
    }
    get preventClose() {
        return true;
    }
    removeTag(event) {
        event.stopPropagation();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcValueComponent, deps: [{ token: KC_SELECTION }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.6", type: KcValueComponent, selector: "kc-value", host: { properties: { "attr.prevent-close": "this.preventClose" } }, ngImport: i0, template: "<ng-container *ngIf=\"value | async as value; else placeholder\">\n  <div>{{ value }}</div>\n</ng-container>\n\n<ng-template #placeholder>\n  <div #ref>\n    <ng-content placeholder></ng-content>\n  </div>\n\n  <span *ngIf=\"!ref.children.length\">Please choose an option</span>\n</ng-template>\n\n<ng-content></ng-content>\n", styles: [""], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcValueComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kc-value', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"value | async as value; else placeholder\">\n  <div>{{ value }}</div>\n</ng-container>\n\n<ng-template #placeholder>\n  <div #ref>\n    <ng-content placeholder></ng-content>\n  </div>\n\n  <span *ngIf=\"!ref.children.length\">Please choose an option</span>\n</ng-template>\n\n<ng-content></ng-content>\n" }]
        }], ctorParameters: () => [{ type: MapEmitSelect, decorators: [{
                    type: Inject,
                    args: [KC_SELECTION]
                }] }], propDecorators: { preventClose: [{
                type: HostBinding,
                args: ['attr.prevent-close']
            }] } });

const DEFAULT_CONNECTED_POSITIONS = [
    {
        originX: 'start',
        originY: 'bottom',
        overlayX: 'start',
        overlayY: 'top',
    },
    {
        originX: 'start',
        originY: 'top',
        overlayX: 'start',
        overlayY: 'bottom',
    },
    {
        originX: 'end',
        originY: 'top',
        overlayX: 'end',
        overlayY: 'bottom',
    },
    {
        originX: 'end',
        originY: 'bottom',
        overlayX: 'end',
        overlayY: 'top',
    },
];

class KcSelectComponent extends KcControl {
    get options() {
        return this._options;
    }
    set options(options) {
        // TODO: check to implement shareReplay
        if (isObservable(options))
            this._options = options;
        else
            this._createObservableOptions(options);
    }
    /**
     * allow user to open selection in modal
     */
    get multiple() {
        return this._multiple;
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    /**
     * allow user to open selection in modal
     */
    get dialog() {
        return this._dialog;
    }
    set dialog(value) {
        this._dialog = coerceBooleanProperty(value);
    }
    set value(val) {
        this._value = val;
        this._cdr.detectChanges();
    }
    get value() {
        return this._value;
    }
    constructor(_overlay, _viewContainerRef, _cdr, _trap, tabIndex) {
        super();
        this._overlay = _overlay;
        this._viewContainerRef = _viewContainerRef;
        this._cdr = _cdr;
        this._trap = _trap;
        this._multiple = false;
        this._dialog = false;
        /**
         * selectionOpened variable is for check if the overlay or dialog is open
         */
        this.selectionOpened = false;
        this.closed = new EventEmitter();
        this.submitted = new EventEmitter();
        this.allSelected = false;
        this._allSelectedChanged = new BehaviorSubject(false);
        this.allSelectedChanged = this._allSelectedChanged.asObservable();
        this.positions = DEFAULT_CONNECTED_POSITIONS;
        this._tabIndex = parseInt(tabIndex) || 0;
        this.cdkOverlayConfig = {
            hasBackdrop: true,
            disposeOnNavigation: true,
            backdropClass: 'cdk-overlay-transparent-backdrop',
        };
    }
    ngOnInit() {
        super.ngOnInit();
        this.selection = new MapEmitSelect(this.multiple);
        this._subscriptionChanges = this._initSelectionModel();
        if (this.origin) {
            // TODO: remove event listener on destroy
            this.origin.elementRef.nativeElement.addEventListener('click', () => {
                if (this.selectionOpened)
                    return;
                this.elementRef.nativeElement.focus();
                this.click();
            });
        }
    }
    ngAfterContentInit() {
        if (this._valueDirective)
            this._valueDirective.render(this._valueRef);
    }
    writeValue(obj) {
        this.value = obj;
        this._updateSelectionModel();
    }
    /**
     * allow element to be focusable
     */
    get tabindex() {
        return this._tabIndex;
    }
    _keydown(event) {
        /**
         * when user focus on element and press space, open selection
         */
        if (event.key === ' ') {
            /**
             * prevent scroll when user press space
             */
            event.preventDefault();
            this.open();
        }
        else if (event.key === 'Escape')
            this.close();
        else if (event.key === 'Tab') {
            if (this.selectionOpened) {
                /**
                 * prevent to focus on next element when selection is opened
                 */
                event.preventDefault();
                this.close();
            }
            else if (this.focused) {
                this.focused = false;
            }
        }
    }
    /**
     * open selection when user click on element
     */
    click() {
        if (this.selectionOpened)
            this.close();
        else
            this.open();
    }
    /**
     * focus on element when user press tab to focus on element
     * and don't open selection, to open selection user need to press space
     */
    _focus() {
        this.focused = true;
        this._stateChanges.next();
    }
    /**
     * close selection when user press tab to blur on element
     */
    _blur() {
        if (this.selectionOpened)
            return;
        /**
         * blur element when user focused element but not open selection
         * and focus on another element but not with tab key but with mouse click
         */
        this.focused = false;
        this._stateChanges.next();
    }
    open() {
        /**
         * skip to open if selection is already opened
         */
        if (this.selectionOpened)
            return;
        this._openOverlay();
        this.selectionOpened = true;
        this._removeOptionsSubscription();
        this._subscriptionOptions = this.options.pipe(takeUntilDestroyed(this._destroy)).subscribe((options) => {
            if (this._groupDirectives.length)
                this._groupDirectives.forEach((group) => group.render(options));
            else if (this._optionsDirectives.length)
                this._optionsDirectives.forEach((optionDirective, index) => optionDirective.render(this._getOptions(options)[index]));
        });
    }
    close() {
        /**
         * skip to close if selection is already closed
         */
        if (!this.selectionOpened)
            return;
        this._closeOverlay();
        this.selectionOpened = false;
        this._removeOptionsSubscription();
        if (this._groupDirectives.length)
            this._groupDirectives.forEach((group) => group.clear());
        else if (this._optionsDirectives.length)
            this._optionsDirectives.forEach((optionDirective) => optionDirective.clear());
        this.onTouchedNew();
        /**
         * mark for check when user try to close from KcSelect token
         */
        this._cdr.markForCheck();
        this.closed.emit(this.value);
        /**
         * stay focused until user click outside of select
         */
        this.elementRef.nativeElement.focus();
    }
    submit() {
        this.close();
        this.submitted.emit(this.value);
        this.clear();
    }
    keydown(event) {
        /**
         * close modal when user press ESC
         */
        if (event.key === 'Escape')
            this.close();
    }
    selectAll() {
        this.optionComponents.forEach((option) => option.select());
    }
    deselectAll() {
        this.optionComponents.forEach((option) => option.deselect());
    }
    toggle() {
        if (this.allSelected)
            this.deselectAll();
        else
            this.selectAll();
    }
    clear() {
        this.allSelected = false;
        this.selection.clear();
    }
    _removeOptionsSubscription() {
        if (!this._subscriptionOptions)
            return;
        this._subscriptionOptions.unsubscribe();
        this._subscriptionOptions = undefined;
    }
    _initSelectionModel() {
        return this._getSelectedOptions
            .pipe(tap((options) => options && this.selection.set(options)), switchMap(() => this.selection.changed), takeUntilDestroyed(this._destroy))
            .subscribe(() => {
            /**
             * When the groups are initialized, the selectionModel changes from the AfterContentInit hook
             * Angular does not expect events to be raised during change detection, so any state change
             * (such as a form control's 'ng-touched') will cause a changed-after-checked error.
             */
            void Promise.resolve().then(() => this._onSelect());
        });
    }
    _updateSelectionModel() {
        if (!this.selection)
            return;
        this._getSelectedOptions
            .pipe(tap((options) => {
            this._subscriptionChanges?.unsubscribe();
            this.selection.clear({ emitEvent: !options?.length });
            if (options?.length)
                this.selection.set(options);
            this._subscriptionChanges = this._initSelectionModel();
        }))
            .subscribe();
    }
    _getOptions(options) {
        if (isOptionChunks(options))
            return options;
        return [options];
    }
    /**
     * check selected options
     */
    get _getSelectedOptions() {
        return this.options.pipe(map((options) => getSelectedOptions(options, this.value)), first());
    }
    _createObservableOptions(options) {
        if (!this._optionsCache) {
            this._optionsCache = new ReplaySubject();
            this._options = this._optionsCache;
        }
        this._optionsCache.next(options);
    }
    _openOverlay() {
        const elementRef = this.origin?.elementRef || this.elementRef;
        const minWidth = elementRef.nativeElement.offsetWidth;
        const overlayRef = this._overlay.create({
            scrollStrategy: this._overlay.scrollStrategies.reposition(),
            positionStrategy: this._getPositionStrategy(elementRef),
            minWidth,
            ...this.cdkOverlayConfig,
        });
        const dialogPortal = new TemplatePortal(this.templateRef, this._viewContainerRef);
        overlayRef.attach(dialogPortal);
        overlayRef
            .backdropClick()
            .pipe(takeUntilDestroyed(this._destroy))
            .subscribe(() => {
            this.close();
            this._stateChanges.next();
        });
        /**
         * trap tab to be inside of modal
         * for example search
         */
        const trap = this._trap.create(overlayRef.overlayElement);
        void trap.focusInitialElementWhenReady().then((successfully) => {
            if (successfully && trap.attachAnchors()) {
                const elements = document.querySelectorAll('.cdk-focus-trap-anchor');
                const first = elements[0];
                const end = elements[elements.length - 1];
                first.addEventListener('focus', () => {
                    trap.destroy();
                    this.elementRef.nativeElement.focus();
                    this.close();
                });
                end.addEventListener('focus', () => {
                    trap.destroy();
                    this.elementRef.nativeElement.focus();
                    this.close();
                });
            }
        });
        this._dialogOverlayRef = overlayRef;
    }
    _getPositionStrategy(elementRef) {
        if (this.dialog) {
            return this._overlay.position().global().centerHorizontally().centerVertically();
        }
        const offsetMargin = Math.max(...this.positions
            .flatMap(({ offsetX, offsetY }) => [offsetX || 0, offsetY || 0])
            .map((offset) => Math.abs(offset)));
        return this._overlay
            .position()
            .flexibleConnectedTo(elementRef)
            .withPush(false)
            .withViewportMargin(20 + offsetMargin)
            .withPositions(this.positions);
    }
    _closeOverlay() {
        this._dialogOverlayRef.dispose();
        this._dialogOverlayRef = undefined;
    }
    /** Invoked when an option is clicked. */
    _onSelect() {
        const valueToEmit = getValues(this.selection);
        this._value = valueToEmit;
        this.onChange(valueToEmit);
        this.allSelected = [...this.optionComponents].every((option) => option.selected);
        this._allSelectedChanged.next(this.allSelected);
        this._stateChanges.next();
        this._cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectComponent, deps: [{ token: i1$1.Overlay }, { token: i0.ViewContainerRef }, { token: i0.ChangeDetectorRef }, { token: i2.ConfigurableFocusTrapFactory }, { token: 'tabindex', attribute: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.6", type: KcSelectComponent, selector: "kc-select", inputs: { options: "options", multiple: "multiple", dialog: "dialog", origin: "origin", cdkOverlayConfig: "cdkOverlayConfig", positions: "positions" }, outputs: { closed: "closed", submitted: "submitted" }, host: { listeners: { "keydown": "_keydown($event)", "click": "click()", "focus": "_focus()", "blur": "_blur()" }, properties: { "attr.tabindex": "this.tabindex" } }, providers: [
            kcControlProviders(KcSelectComponent),
            {
                provide: KC_SELECT,
                useExisting: forwardRef(() => KcSelectComponent),
            },
            {
                provide: KC_SELECTION,
                useFactory: (component) => component.selection,
                deps: [forwardRef(() => KcSelectComponent)],
            },
            {
                provide: KC_VALUE,
                useFactory: (component) => component.value,
                deps: [forwardRef(() => KcSelectComponent)],
            },
        ], queries: [{ propertyName: "_valueDirective", first: true, predicate: KcValueDirective, descendants: true, static: true }, { propertyName: "optionComponents", predicate: KcOptionComponent, descendants: true }, { propertyName: "_groupDirectives", predicate: KcGroupDirective, descendants: true }, { propertyName: "_optionsDirectives", predicate: KcOptionsDirective, descendants: true }], viewQueries: [{ propertyName: "_valueRef", first: true, predicate: ["valueRef"], descendants: true, read: ViewContainerRef, static: true }, { propertyName: "templateRef", first: true, predicate: ["templateRef"], descendants: true, static: true }], exportAs: ["kcSelect"], usesInheritance: true, ngImport: i0, template: "<ng-template #valueRef></ng-template>\n\n<ng-template #templateRef>\n  <ng-content></ng-content>\n</ng-template>\n", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kc-select', providers: [
                        kcControlProviders(KcSelectComponent),
                        {
                            provide: KC_SELECT,
                            useExisting: forwardRef(() => KcSelectComponent),
                        },
                        {
                            provide: KC_SELECTION,
                            useFactory: (component) => component.selection,
                            deps: [forwardRef(() => KcSelectComponent)],
                        },
                        {
                            provide: KC_VALUE,
                            useFactory: (component) => component.value,
                            deps: [forwardRef(() => KcSelectComponent)],
                        },
                    ], changeDetection: ChangeDetectionStrategy.OnPush, exportAs: 'kcSelect', template: "<ng-template #valueRef></ng-template>\n\n<ng-template #templateRef>\n  <ng-content></ng-content>\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1$1.Overlay }, { type: i0.ViewContainerRef }, { type: i0.ChangeDetectorRef }, { type: i2.ConfigurableFocusTrapFactory }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['tabindex']
                }] }], propDecorators: { options: [{
                type: Input
            }], multiple: [{
                type: Input
            }], dialog: [{
                type: Input
            }], origin: [{
                type: Input
            }], cdkOverlayConfig: [{
                type: Input
            }], positions: [{
                type: Input
            }], closed: [{
                type: Output
            }], submitted: [{
                type: Output
            }], _valueRef: [{
                type: ViewChild,
                args: ['valueRef', { read: ViewContainerRef, static: true }]
            }], templateRef: [{
                type: ViewChild,
                args: ['templateRef', { static: true }]
            }], optionComponents: [{
                type: ContentChildren,
                args: [KcOptionComponent, { descendants: true }]
            }], _valueDirective: [{
                type: ContentChild,
                args: [KcValueDirective, { static: true }]
            }], _groupDirectives: [{
                type: ContentChildren,
                args: [KcGroupDirective, { descendants: true }]
            }], _optionsDirectives: [{
                type: ContentChildren,
                args: [KcOptionsDirective, { descendants: true }]
            }], tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }], _keydown: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }], click: [{
                type: HostListener,
                args: ['click']
            }], _focus: [{
                type: HostListener,
                args: ['focus']
            }], _blur: [{
                type: HostListener,
                args: ['blur']
            }] } });

const components = [KcSelectComponent, KcValueComponent, KcGroupComponent, KcOptionsComponent, KcOptionComponent];
const directives = [
    KcValueDirective,
    KcGroupDirective,
    KcOptionsDirective,
    KcOptionDirective,
    KcCloseDirective,
    KcSelectAllDirective,
    KcDeselectAllDirective,
    KcToggleDirective,
    KcClearDirective,
    KcSubmitDirective,
    KcOriginDirective,
];
class KcSelectModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.6", ngImport: i0, type: KcSelectModule, declarations: [KcSelectComponent, KcValueComponent, KcGroupComponent, KcOptionsComponent, KcOptionComponent, KcValueDirective,
            KcGroupDirective,
            KcOptionsDirective,
            KcOptionDirective,
            KcCloseDirective,
            KcSelectAllDirective,
            KcDeselectAllDirective,
            KcToggleDirective,
            KcClearDirective,
            KcSubmitDirective,
            KcOriginDirective], imports: [CommonModule, OverlayModule], exports: [KcSelectComponent, KcValueComponent, KcGroupComponent, KcOptionsComponent, KcOptionComponent, KcValueDirective,
            KcGroupDirective,
            KcOptionsDirective,
            KcOptionDirective,
            KcCloseDirective,
            KcSelectAllDirective,
            KcDeselectAllDirective,
            KcToggleDirective,
            KcClearDirective,
            KcSubmitDirective,
            KcOriginDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectModule, imports: [CommonModule, OverlayModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.6", ngImport: i0, type: KcSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [...components, ...directives],
                    imports: [CommonModule, OverlayModule],
                    exports: [...components, ...directives],
                }]
        }] });

/**
 * options type for input options
 */
// TODO: move K to be second generic and put default to unknown

/*
 * Public API Surface of select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { KC_SELECT, KC_SELECTION, KC_VALUE, KcClearDirective, KcCloseDirective, KcDeselectAllDirective, KcGroupComponent, KcGroupDirective, KcOptionComponent, KcOptionDirective, KcOptionsComponent, KcOptionsDirective, KcOriginDirective, KcSelectAllDirective, KcSelectComponent, KcSelectModule, KcSubmitDirective, KcToggleDirective, KcValueComponent, KcValueDirective, MapEmitSelect, filterNestedOptions, getSelectedOptions, getValues, isOptionChunks, provideKcOption };
//# sourceMappingURL=k5cjs-select.mjs.map
